<?php
/*
* Copyright (c) 2010 by Justin Otherguy <justin@justinotherguy.org>
*
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License (either version 2 or
* version 3) as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* For more information on the GPL, please go to:
* http://www.gnu.org/copyleft/gpl.html
*/

require_once 'common.php';

	
	function make_a_difference($system_date, $sent_date) {
		// erwartet beide Daten als Unix-Epoch (Sekunden seit 1970-01-01 00:00:00)
		return $system_date - $sent_date;
	}
	
	$controller     = $_REQUEST['controller'];
	$controllertime = $_REQUEST['controllertime'];
	$port           = $_REQUEST['port'];
	
	// checking required parameters
	
	// uuid=<01234567-89AB-CDEF...>
	if (!preg_match("^[0-9A-Z-]+$", $controller))
		throw new InvalidArgumentException("Parameter uuid is invalid: $controller");
	
	// time=<timestamp>
	if (!$controllertime)
		throw new InvalidArgumentException("Parameter controllertime is invalid: $controllertime");
	
	// port=P{ABCD}{0-7}
	if (!preg_match("^[A-Z0-9]{2}$",$port))
		throw new InvalidArgumentException("Parameter port is invalid: $port");
	
	sql_connect('smlogger');
	
	// die DB-interne ID des Controllers ermitteln
	$interne_id = sql_field("SELECT id from ".TABLE_PREFIX."channels where uuid = '$controller' and channel = '$port'");
	
	// falls diese aber leer ist (= noch nicht in der DB existiert), ebenfalls abbrechen
	if (!$interne_id)
		throw new InvalidArgumentException("uuid has not been approved yet");
	
	$time_delta = make_a_difference($controllertime, microtime(true));
	$result = sql_query("INSERT INTO ".TABLE_PREFIX."pulses (servertime, controllertime, time_delta, channel, id) VALUES (NOW(), to_timestamp('$controllertime'), $time_delta, '$port', '$interne_id' )");
	
	// optional passthru to volkszaehler.org
	if ($httplog_passthru===true || $httplog_passthru=="yes") {
		file_get_contents("http://volkszaehler.org/httplog/httplog.php?" . $_SERVER['QUERY_STRING'] . "&passthru=yes");
	}

?>
