<?php
/*
* Copyright (c) 2010 by Justin Otherguy <justin@justinotherguy.org>
* 
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License (either version 2 or
* version 3) as published by the Free Software Foundation.
*     
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*     
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*     
* For more information on the GPL, please go to:
* http://www.gnu.org/copyleft/gpl.html
*/

require_once 'smartmeter.conf.php';
require_once 'exceptions.php';
require_once 'sql.php';

	function UnixTime($psql_timestamp){
		if(preg_match('/(\d{4})\-(\d{2})\-(\d{2}) (\d{2}):(\d{2}):(\d{2}).(\d{6})/', $psql_timestamp, $pieces)
			|| preg_match('/(\d{4})\-(\d{2})\-(\d{2}) (\d{2}):(\d{2}):(\d{2}).(\d{5})/', $psql_timestamp, $pieces)
			|| preg_match('/(\d{4})\-(\d{2})\-(\d{2}) (\d{2}):(\d{2}):(\d{2}).(\d{4})/', $psql_timestamp, $pieces)
			|| preg_match('/(\d{4})\-(\d{2})\-(\d{2}) (\d{2}):(\d{2}):(\d{2}).(\d{3})/', $psql_timestamp, $pieces)
			|| preg_match('/(\d{4})\-(\d{2})\-(\d{2}) (\d{2}):(\d{2}):(\d{2}).(\d{2})/', $psql_timestamp, $pieces)
			|| preg_match('/(\d{4})\-(\d{2})\-(\d{2}) (\d{2}):(\d{2}):(\d{2}).(\d{1})/', $psql_timestamp, $pieces)
			|| preg_match('/(\d{4})\-(\d{2})\-(\d{2}) (\d{2}):(\d{2}):(\d{2})/', $psql_timestamp, $pieces)
			|| preg_match('/(\d{2})\-(\d{2})\-(\d{2}) (\d{2}):(\d{2}):(\d{2}).(\d{6})/', $psql_timestamp, $pieces)
			|| preg_match('/(\d{2})\-(\d{2})\-(\d{2}) (\d{2}):(\d{2}):(\d{2}).(\d{5})/', $psql_timestamp, $pieces)
			|| preg_match('/(\d{2})\-(\d{2})\-(\d{2}) (\d{2}):(\d{2}):(\d{2}).(\d{4})/', $psql_timestamp, $pieces)
			|| preg_match('/(\d{4})\-(\d{2})\-(\d{2})/', $psql_timestamp, $pieces)
			|| preg_match('/(\d{2})\-(\d{2})\-(\d{2})/', $psql_timestamp, $pieces)) {
			$unix_time = strtotime($psql_timestamp);
			$unix_time = $unix_time + $pieces[7]/(pow(10, strlen($pieces[7])))." ";
		}
		return $unix_time;
	} 

	
	function init($uuid){
		global $interne_id, $resolution, $min, $imp_min, $max, $imp_max;
		//error_reporting (E_ERROR | E_WARNING | E_PARSE | E_NOTICE);
		
		if(!$uuid){
			echo "Parameter uuid is required - running in demo mode!";
			$uuid = DEMO_UUID;
			$min = "2010-04-01, 00:00";
			$imp_min = UnixTime($min);
			$max = "2010-04-02, 00:00";
			$imp_max = UnixTime("2010-04-02, 00:00");
		}
		
		sql_connect('smreader');
		
		// die DB-interne ID des Controllers
		$interne_id = sql_field("SELECT id from ".TABLE_PREFIX."channels WHERE uuid = '".sql_escape($uuid)."'");
		
		# set (explicit) min and imp_min
		if ( $_GET["min"] != "" ) { 
			$min = UnixTime($_GET["min"]);
			$imp_min = $min;
		} else {
			if ($uuid == DEMO_UUID) {
				// running in demo mode
				$min = "2010-04-01, 00:00";
				$imp_min = UnixTime($min);
			} else {
				$imp_min = (date ("U",time())-86400);
			}
		}
		# do the same for max and imp_max
		if ( $_GET["max"] != "" ) { 
			$max = UnixTime($_GET["max"]);
			$imp_max = $max;
		} else {
			if ($uuid == DEMO_UUID) {
				// running in demo mode
				$max = "2010-04-02, 00:00";
				$imp_max = UnixTime("2010-04-02, 00:00");
			} else {
				$imp_max = date("U");
			}
		}
		# mal sehen, ob resolution mit angegeben wurde
		if ( $_GET["resolution"] != "" ) {
			$resolution = $_GET["resolution"];
		}
	
		global $teiler, $anfang, $ende, $delta;
		
		$anfang=date("Y-m-d H:i:s", $imp_min);
		$ende=date("Y-m-d H:i:s", $imp_max);
		$delta=UnixTime($ende)-UnixTime($anfang);
		
		// FIXME ?!
		return $uuid;
		
		echo $_SERVER['PHP_SELF']."?min=".date("Y-m-d, H:i:s", $imp_min - $delta/3);
		echo "&max=".date("Y-m-d, H:i:s", $imp_max - $delta/3);
		if ( $resolution != "" ) { 
			echo "&resolution=". $resolution;
		}
		echo "&uuid=".$uuid;
	}

	function screenwidth(){
		if ( strstr ($_SERVER['HTTP_USER_AGENT'], 'iPhone')) {
			echo '320';
		} else {
			echo '1000';
		} 
	}
	
	function width(){
		if ( strstr ($_SERVER['HTTP_USER_AGENT'], 'iPhone')) {
			echo 'width:'.'310px;height:200px;';
		} else {
			echo 'width:'.'1000px;height:550px;';
		}
	}

	function get_refresh_interval() {
		global $delta;
		# minimum: 2sec.
		$refresh_interval = (round(($delta/500),0)+2);
		return $refresh_interval;
	}

	function current_power($channel) {
	}

	function calc_energy($id, $anfang, $ende) {
		$anzahl = sql_field("SELECT COUNT(*) from ".TABLE_PREFIX."pulses where id='$id' and servertime > '$anfang' and servertime < '$ende'");
		
		if ($id == "3") {
			$energy = $anzahl/1000;
		} else {
			$energy = $anzahl/2000;
		}
		return $energy;
	}
	
	function calc_consumed_energy($id) {
		global $anfang, $ende;

		$energy = calc_energy($id, $anfang, $ende);
		return $energy;
	}

	function calc_leistung_avg($id) {
		global $anfang, $ende, $delta;

		$energy = calc_consumed_energy($id);
		$leistung_avg = $energy*1000*3600/($delta);
		return $leistung_avg;
	}

	function fill_array ($id, $anfang, $ende, $schwelle, $teiler) {
		for ($i=1; $i<$teiler; $i++ ) {
			$delta=UnixTime($ende)-UnixTime($anfang);
			$schritt_anfang = date("Y-m-d H:i:s", (UnixTime($anfang) + $i*$delta/$teiler));
			$schritt_ende = date("Y-m-d H:i:s", UnixTime($anfang) + ($i+1)*$delta/$teiler);
			$schritt_delta = UnixTime($schritt_ende)-UnixTime($schritt_anfang);
			$anzahl = field("SELECT COUNT(*) from ".TABLE_PREFIX."pulses where id='$id' and servertime > '$schritt_anfang' and servertime < '$schritt_ende'");
			$schritt_delta = UnixTime($schritt_ende)-UnixTime($schritt_anfang);
			
			if ($anzahl >= $schwelle ){
				# -> "Zaehlmodus" = es sind genügend Impulse für die Berechnung eines zuverlässigen Durchschnitts für dieses Intervall vorhanden
				if ($id == "3") {
					$leistung = $anzahl/1000*1000*3600/($schritt_delta);
				} else {
					$leistung = $anzahl/2000*1000*3600/($schritt_delta);
				}
				$neue_Zeit = $schritt_anfang;
				$PC [ UnixTime($neue_Zeit) ] = $leistung;
			} else {
				# -> "Direktmodus" = alle Messwerte auslesen
				$result = sql_query("SELECT * from ".TABLE_PREFIX."pulses where id='$id' and servertime > '$schritt_anfang' and servertime < '$schritt_ende'");
				while($line = pg_fetch_array($result)) {
					$alte_Zeit = $neue_Zeit;
					$neue_Zeit = $line['servertime'];
					if (($alte_Zeit != 0) and ($neue_Zeit != 0)) {
						# nur wenn beide != 0 sind
						$differenz = UnixTime($neue_Zeit) - UnixTime($alte_Zeit);
						if ($id == "3") {
							$leistung = 3600*1000/($differenz*1000);
						} else {
							$leistung = 3600*1000/($differenz*2000);
						}
						$PC [ UnixTime($neue_Zeit) ] = $leistung;
					}
					$neue_Zeit = $neue_Zeit;
				} 
			}
		}
		return $PC;
	}

	function fill_data_arrays($id_0, $id_1, $id_2) {
		global $resolution, $anfang, $ende, $delta, $teiler, $leistung_PC0, $leistung_PC1, $leistung_PC2, $PC0, $PC1, $PC2, $leistung_PC0_max, $leistung_PC1_max, $leistung_PC2_max, $leistung_PC0_min, $leistung_PC1_min, $leistung_PC2_min;
		$schwelle = 10;
		if ($resolution != "") {
			$teiler=($delta/$resolution);
		} else {
			$teiler=100;
		}
		if (strlen($id_0) != 0) $PC0 = fill_array($id_0, $anfang, $ende, $schwelle, $teiler);
		if (strlen($id_1) != 0) $PC1 = fill_array($id_1, $anfang, $ende, $schwelle, $teiler);
		if (strlen($id_2) != 0) $PC2 = fill_array($id_2, $anfang, $ende, $schwelle, $teiler);

		if (count($PC0)) { 
			$leistung_PC0_min = min($PC0); 
			$leistung_PC0_max = max($PC0); 
		};
		if (count($PC1)) { 
			$leistung_PC1_min = min($PC1); 
			$leistung_PC1_max = max($PC1); 
		};
		if (count($PC2)) { 
			$leistung_PC2_min = min($PC2); 
			$leistung_PC2_max = max($PC2); 
		};
	}

	function array_print($item2, $key) {
		#js erwartet unixtimestamp in us -> *1000
		#js berücksichtigt nicht die Zeitzone -> Korrektur für Arme: +3600s
		$keyx1000 = 1000*($key+3600);
		echo "[ $keyx1000, $item2], ";
	}	
		
	function move_one_third_left() {
		global $resolution, $imp_min, $imp_max, $delta, $uuid;
		echo $_SERVER['PHP_SELF']."?min=".date("Y-m-d, H:i:s", $imp_min - $delta/3);
		echo "&max=".date("Y-m-d, H:i:s", $imp_max - $delta/3);
		if ( $resolution != "" ) { 
			echo "&resolution=". $resolution;
		}
		echo "&uuid=".$uuid;
	}

	function move_one_third_right() {
		global $resolution, $imp_min, $imp_max, $delta, $uuid;
		echo $_SERVER['PHP_SELF']."?min=".date("Y-m-d, H:i:s", $imp_min + $delta/3);
		echo "&max=".date("Y-m-d, H:i:s", $imp_max + $delta/3);
		if ( $resolution != "" ) { 
			echo "&resolution=". $resolution;
		}
		echo "&uuid=".$uuid;
	}
		
	function move_left() {
		global $resolution, $imp_min, $imp_max, $delta, $uuid;
		echo $_SERVER['PHP_SELF']."?min=".date("Y-m-d, H:i:s", $imp_min - $delta);
		echo "&max=".date("Y-m-d, H:i:s", $imp_max - $delta);
		if ( $resolution != "" ) { 
			echo "&resolution=". $resolution;
		}
		echo "&uuid=".$uuid;
	}
		
	function move_right() {
		global $resolution, $imp_min, $imp_max, $delta, $uuid;
		echo $_SERVER['PHP_SELF']."?min=".date("Y-m-d, H:i:s", $imp_min + $delta);
		echo "&max=".date("Y-m-d, H:i:s", $imp_max + $delta);
		if ( $resolution != "" ) { 
			echo "&resolution=". $resolution;
		}
		echo "&uuid=".$uuid;
	}
		
	function half_window_size(){
		global $resolution, $imp_min, $imp_max, $max, $uuid;
		echo $_SERVER['PHP_SELF']."?min=".date("Y-m-d, H:i:s", $imp_max - ($imp_max-$imp_min)/2 );
		if ( $max != "" ) { 
			echo "&max=".date("Y-m-d, H:i:s", $imp_max);
		}
		if ( $resolution != "" ) { 
			echo "&resolution=". $resolution;
		}
		echo "&uuid=".$uuid;
	}

	function double_window_size(){
		global $resolution, $imp_min, $imp_max, $max, $uuid;
		echo $_SERVER['PHP_SELF']."?min=".date("Y-m-d, H:i:s", $imp_max - ($imp_max-$imp_min)*2 );
		if ( $max != "" ) { 
			echo "&max=".date("Y-m-d, H:i:s", $imp_max);
		}
		if ( $resolution != "" ) { 
			echo "&resolution=". $resolution;
		}
		echo "&uuid=".$uuid;
	}


?>