<?php
/*
* Copyright (c) 2010 by Justin Otherguy <justin@justinotherguy.org>
* 
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License (either version 2 or
* version 3) as published by the Free Software Foundation.
*     
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*     
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*     
* For more information on the GPL, please go to:
* http://www.gnu.org/copyleft/gpl.html
*/

/**
 * Über Exceptions:
 * http://php.net/manual/de/language.exceptions.php
 * http://php.net/set_exception_handler
 */

class InvalidArgumentException extends Exception {}
class SqlException extends Exception {}

function handleException($exception) {
	global $debug;
	
	header("Content-Type: text/plain");
	
	if ($exception instanceof InvalidArgumentException)
		header("HTTP/1.0 422 Unprocessable Entity");
	else
		header("HTTP/1.1 500 Internal Error");
	
	if($debug){
		// Be verbose
		echo $e;
	}
	else{
		// Be quiet
		echo get_class($e);
	}
}

set_exception_handler('handleException');

?>