<?php
/*
* Copyright (c) 2010 by Justin Otherguy <justin@justinotherguy.org>
* 
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License (either version 2 or
* version 3) as published by the Free Software Foundation.
*     
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*     
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*     
* For more information on the GPL, please go to:
* http://www.gnu.org/copyleft/gpl.html
*/

function sql_escape($string){
	return pg_escape_string($string);
}

/**
 * connects to database
 * 
 * @param $user
 * @return unknown_type
 */
function sql_connect($user){
	$conn = pg_connect("dbname=smartmeter host=localhost user=".$GLOBALS[$user."_user"]." password=".$GLOBALS[$user."_password"]);
	
	if (!$conn)
		throw new SqlException("Connection to database failed: " . pg_last_error());
	
	return $conn;
}

/**
 * executes an sql query
 * 
 * @param $query
 * @return result
 */
function sql_query($query){
	$result = pg_query($query);
	
	if (!$result)
		throw new SqlException("Query failed: " . pg_last_error());
	
	return $result;
}

/**
 * executes an sql query and returns the first field
 * 
 * @param $query
 * @return result
 */
function sql_field($query){
	$result = sql_query($query);
	$row = pg_fetch_row($result);
	return $row[0];
}

?>